
// My64TestDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "My64TestDemo.h"
#include "My64TestDemoDlg.h"
#include "afxdialogex.h"
#include "IdtLib.h"
#include <winscard.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


static SCARDCONTEXT			ContextHandle = NULL;
static SCARDHANDLE			CardHandle;	
char ReaderName[56];

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CMy64TestDemoDlg dialog



CMy64TestDemoDlg::CMy64TestDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMy64TestDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy64TestDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy64TestDemoDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CMy64TestDemoDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CMy64TestDemoDlg message handlers

BOOL CMy64TestDemoDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	#define MAX_RESPONSE		600
	#define MAX_RDR_MSG_LEN_WITH_ENVELOPE	261
	#define BUF_LENGTH 512
	#define MAX_MAG_BUFFER_SIZE 306

	BYTE	pResponseBuffer[MAX_RESPONSE];
	DWORD	respBufferLength = MAX_RDR_MSG_LEN_WITH_ENVELOPE;
	BYTE	respBuffer[MAX_RDR_MSG_LEN_WITH_ENVELOPE];
	CString		MessageBuffer;


	//	Open communication context with the Resource Manager
	long ret = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &ContextHandle);
	if (ret != SCARD_S_SUCCESS) {
		return IDCANCEL;
	}
	int ReaderCount = 0;
	DWORD ResponseLength = MAX_RESPONSE;

	ret = SCardListReaders(ContextHandle, 0, (char *)pResponseBuffer, &ResponseLength);
	if (ret != SCARD_S_SUCCESS) {
		return IDCANCEL;
	}
	else {
		unsigned int	StringLen = 0;

		while (ResponseLength > StringLen + 1) {
				DWORD	ActiveProtocol = 0;
				strcpy(ReaderName, (LPCTSTR)pResponseBuffer + StringLen);
				ret = SCardConnect(ContextHandle, ReaderName, SCARD_SHARE_SHARED,
				SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1, &CardHandle, &ActiveProtocol);

			ret = SCardConnect(ContextHandle, ReaderName, SCARD_SHARE_SHARED,
				SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1, &CardHandle, &ActiveProtocol);
			if (ret != SCARD_E_UNKNOWN_READER)
				ReaderCount++;
			if (ret == SCARD_S_SUCCESS)
				SCardDisconnect(CardHandle, SCARD_EJECT_CARD);
			StringLen += strlen((LPCTSTR)pResponseBuffer + StringLen + 1);
			StringLen += 2;
		}
	}
	if (ReaderCount == 0) {
		return IDCANCEL;
	}
	
	
	// request reader version string
	// IDTCCIDLIB.DLL must be at least 1.00 to support IdtGetReaderState
	// as of 03Oct2011AD demo for CCID version and needs idtcciddll.dll verison 1.14
	ret = IdtGetVersion(respBuffer, &respBufferLength);	// Get the version of the DLL
	if (ret != SCARD_S_SUCCESS) {
		
	}
	else {
	}


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy64TestDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMy64TestDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy64TestDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CMy64TestDemoDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	CDialogEx::OnOK();


}
